"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const swc = __importStar(require("@swc/core"));
const plugin_react_1 = __importDefault(require("@vitejs/plugin-react"));
function react(options = {}) {
    const { swcOptions = {} } = options;
    let configEnv = null;
    return [
        ...(0, plugin_react_1.default)(),
        {
            name: 'vite-plugin-swc-react',
            enforce: 'pre',
            config(_config, env) {
                configEnv = env;
            },
            transform(code, id) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (/\.(js|[tj]sx?)$/.test(id)) {
                        let isTypescript = ['.ts', '.tsx'].some((p) => id.endsWith(p));
                        let is_SX = ['.jsx', '.tsx'].some((p) => id.endsWith(p));
                        let isDevelopment = configEnv.mode === 'development';
                        return yield swc.transform(code, Object.assign({ filename: id, jsc: {
                                parser: isTypescript
                                    ? {
                                        syntax: 'typescript',
                                        tsx: is_SX,
                                    }
                                    : {
                                        syntax: 'ecmascript',
                                        jsx: is_SX,
                                    },
                                transform: {
                                    react: {
                                        development: isDevelopment,
                                        runtime: 'automatic',
                                        refresh: true,
                                    },
                                },
                            } }, swcOptions));
                    }
                });
            },
        },
    ];
}
exports.default = react;
